/*******************************************************************
 * Data Visualization - Depression, Melancholia, Boredom, Tedium    *
 * Tested in Processing 3                                           *     
 *                                                                  *
 * Author: Yichen Li                                                *
 * Supervisor: Rodger Luo                                           *
 * Supervisor: George Legrady                                       *
 *                                                                  *
 * Purpose: Demonstrate the checkout behavior and keep duration of  *
            books with titles containing variations of words        *
            "depression", "melancholia", "boredom", and "tedium"    *
 *          Visualized with different color schemes.                * 
 *                                                                  *
 * Usage(not functional):                                           *
 *          Press 'r', 'c', to apply different                      *
 *          color schemes.                                          *
 *          Press 'b' to use gray scale.                            *
 *******************************************************************/
Table table;
int beginX = 10;
int beginY = 10;
int transparency = 90;
color fill_color = color(0,0,0);
color fill_color_rgb = color(0,0,0);
color fill_color_cmyk = color(0,0,0);
color fill_color_b = color(0,0,0);
int info_x = 1500;
void setup(){
  size(2100,1807);
  table = loadTable("sql2016_ennui.csv", "header");
  noCursor();
  frameRate(120);
  PFont font;
  font =createFont("Futura-Medium.ttf",32);
  textFont(font);
}

void comma(int startY, int endY, int axisX, String sign){
  textSize(20);
  //this is our base text size
  textAlign(LEFT);
  for (int i=startY;i<endY+1;i+=20){
    text(sign,axisX,i);
  }
  //text(sign,axisX,startY);
}

void draw(){
  translate(76,0);
  background(255);
  //comma(100,500,30, "B");
  //comma(100,500,90, "D");
  for (TableRow row : table.rows()) {
    int cout_month = row.getInt("MONTH(cout)");
    //ranges from 1 to 12
    int cout_day = row.getInt("DAY(cout)");
    //ranges from 1 to 31
    int cout_hour = row.getInt("HOUR(cout)")-10;
    int cin_month = row.getInt("MONTH(cin)");
    int cin_day = row.getInt("DAY(cin)");
    int cin_hour = row.getInt("HOUR(cin)");
    //ranges similar to that of cout
    int startY = (cout_month*31+cout_day)*4;
    int endY = (cin_month*31+cin_day)*4;
    boolean depression = boolean(row.getInt("depression"));
    boolean melancholia = boolean(row.getInt("melancholia"));
    boolean tedium = boolean(row.getInt("tedium"));
    boolean boredom = boolean(row.getInt("boredom"));
    int axisX = 800;
    String sign = ".";
    String title = row.getString("title");
    textSize(15);
    if (depression){
      fill_color_rgb = color(0,transparency); 
      fill_color_cmyk = color(0,transparency); 
      axisX = 400*2;
      sign = "|";
      fill(fill_color);
      //fill(fill_color_cmyk);
      //fill(fill_color_rgb);
      //fill(fill_color_b);
      text(" /", 100+(axisX/50+32*20)*2, 1700-axisX/20);
      text("depression",info_x,1700-axisX/20);
    }
    else if (melancholia){
      fill_color_rgb = color(0,200,0,transparency);
      fill_color_cmyk = color(204,204,0,transparency);
      axisX = 250*2;
      sign = ";;";
      fill(fill_color);
      //fill(fill_color_cmyk);
      //fill(fill_color_rgb);
      //fill(fill_color_b);
      text(" /", 100+(axisX/50+32*20)*2, 1700-axisX/20);
      text("meancholia",info_x,1700-axisX/20);
    }
    else if (tedium){
      fill_color_rgb = color(0,0,200,transparency);
      fill_color_cmyk =color(0,255,255,transparency);
      axisX = 550*2;
      sign = "/";
      fill(fill_color);
      //fill(fill_color_cmyk);
      //fill(fill_color_rgb);
      //fill(fill_color_b);
      text(" /", 100+(axisX/50+32*20)*2, 1700-axisX/20);
      text("tedium",info_x,1700-axisX/20);
    }
    else if (boredom){
      fill_color_rgb = color(200,0,0,transparency);
      fill_color_cmyk =color(255,0,255,transparency);
      axisX = 100*2;
      sign = "*";
      fill(fill_color);
      //fill(fill_color_cmyk);
      //fill(fill_color_rgb);
      //fill(fill_color_b);
      text(" /", 100+(axisX/50+32*20)*2, 1700-axisX/20);
      text("boredom",info_x,1700-axisX/20);
    }
    //fill(fill_color_cmyk);
    fill(fill_color_rgb);
    //fill(fill_color_b);
    comma(startY, endY, 100+(axisX/50+cout_day*20+cout_hour*2)*2, sign);
    textSize(15);
    // this is smallest font size, 15 = floor(20/3)
    text(cout_day, 100+(axisX/50+cout_day*20)*2, 1700-axisX/20);
    
    stroke(255,0,0);
    line(130,mouseY, 1483, mouseY);
    line(mouseX,115, mouseX,1615);
    fill(0);
    textSize(15);
    text("checkout month:"+ str(cout_month), info_x, mouseY-72);
    text("checkout date:"+ str(cout_day), info_x, mouseY-48);
    text("checkout hour:"+ str(cout_hour), info_x, mouseY-24);
    if ((mouseX-(100+(axisX/50+cout_day*20+cout_hour*2)*2))<2 && (mouseY-startY)<2){
      //fill(fill_color_cmyk);
      fill(fill_color_rgb);
      //fill(fill_color_b);
      //text(title, 1000, mouseY+axisX*12/150+cout_month*31*10+cout_day*10+cout_hour);
      text(title, info_x, mouseY+axisX*12/150);
  }
  }
  for (int n=1; n<13;n++){
    fill(0);
    textSize(10);
    //line(10,n*31*2*2, 20, n*31*2*2);
    for (int m=0; m<n;m++){
      textAlign(RIGHT);
      text('/',100-5*m,n*31*2*2);
  }
  
  save("2_rgb.png");
}
if (keyPressed==true){
  if (key == 'r'){
    fill_color = fill_color_rgb;
    print(key);
  }
  if (key =='c'){
    fill_color = fill_color_cmyk;
    print(key);
  }
  if (key =='k'){
    fill_color = (0);
  }
}
}
